<ui:composition xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:a4j="http://richfaces.org/a4j" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns="http://www.w3.org/1999/xhtml" xmlns:rich="http://richfaces.org/rich"
                xmlns:g="http://www.ihe.net/gazelle">
    <!-- expected parameters:
          managedBean : name of the main bean used in the page including this page
      -->
    <ui:decorate template="/layout/panels/_panel_title_footer_id.xhtml">
        <ui:param name="panel_id" value="messageConfigurationPanel"/>
        <ui:define name="panel_title">#{messages['gazelle.pam.MessageConfiguration']}</ui:define>
        <ui:insert name="helpText"/>
        <a4j:commandButton value="#{messages['gazelle.pam.GenerateAPatient']}" id="toDDsBtn"
                           styleClass="gzl-btn-blue" render="messageConfigurationPanel"
                           actionListener="#{managedBean.switchToGenerationMode()}"
                           rendered="#{allowPatientGeneration and managedBean.displayPatientsList}"/>
        <br/><br/>
        <s:decorate template="/layout/panels/_panel_filter_criteria.xhtml"
                    rendered="#{managedBean.displayPatientsList}">
            <ui:param name="panel_id" value="patientSelection"/>
            <div class="row">
                <div class="col-lg-4">
                    <ui:include src="/filter/filter.xhtml">
                        <ui:param name="filterWidth" value="240"/>
                        <ui:param name="filter" value="#{managedBean.filter}"/>
                        <ui:param name="filterId" value="lastname"/>
                        <ui:param name="filterName" value="#{messages['gazelle.pam.LastName']}"/>
                        <ui:param name="filterForm" value="messageConfigurationPanel"/>
                    </ui:include>
                </div>
                <div class="col-lg-4">
                    <ui:include src="/filter/filter.xhtml">
                        <ui:param name="filterWidth" value="240"/>
                        <ui:param name="filter" value="#{managedBean.filter}"/>
                        <ui:param name="filterId" value="firstname"/>
                        <ui:param name="filterName" value="#{messages['gazelle.pam.FirstName']}"/>
                        <ui:param name="filterForm" value="messageConfigurationPanel"/>
                    </ui:include>
                </div>
                <div class="col-lg-4">
                    <ui:include src="/filter/filter.xhtml">
                        <ui:param name="filterWidth" value="240"/>
                        <ui:param name="filter" value="#{managedBean.filter}"/>
                        <ui:param name="filterId" value="gender"/>
                        <ui:param name="filterName" value="#{messages['gazelle.simulator.PatientGeneration.Gender']}"/>
                        <ui:param name="filterForm" value="messageConfigurationPanel"/>
                    </ui:include>
                </div>
            </div>
            <div class="row">
                <div class="col-lg-4">
                    <ui:include src="/filter/filter.xhtml">
                        <ui:param name="filterWidth" value="240"/>
                        <ui:param name="filter" value="#{managedBean.filter}"/>
                        <ui:param name="filterId" value="mothersmaidenname"/>
                        <ui:param name="filterName" value="#{messages['gazelle.simulator.pam.MothersMaidenName']}"/>
                        <ui:param name="filterForm" value="messageConfigurationPanel"/>
                    </ui:include>
                </div>
                <div class="col-lg-4">
                    <ui:include src="/filter/filter.xhtml">
                        <ui:param name="filterWidth" value="240"/>
                        <ui:param name="filter" value="#{managedBean.filter}"/>
                        <ui:param name="filterId" value="country"/>
                        <ui:param name="filterName" value="#{messages['gazelle.simulator.PatientGeneration.Country']}"/>
                        <ui:param name="filterForm" value="messageConfigurationPanel"/>
                    </ui:include>
                </div>
                <div class="col-lg-4">
                    <ui:include src="/filter/filter.xhtml">
                        <ui:param name="filterWidth" value="240"/>
                        <ui:param name="filter" value="#{managedBean.filter}"/>
                        <ui:param name="filterId" value="owner"/>
                        <ui:param name="filterName" value="#{messages['gazelle.HL7Common.Owner']}"/>
                        <ui:param name="filterForm" value="messageConfigurationPanel"/>
                    </ui:include>
                </div>
            </div>
            <div class="col-lg-4">
                <s:decorate template="/layout/form/_form_field_horizontal_4-8.xhtml">
                    <ui:param name="id" value="idInput"/>
                    <ui:define name="label">#{messages['gazelle.pam.Identifier']}</ui:define>
                    <h:inputText id="idInput" value="#{managedBean.searchedPatientId}" styleClass="form-control">
                        <a4j:ajax event="keyup" render="messageConfigurationPanel"/>
                    </h:inputText>
                </s:decorate>
            </div>
            <ui:define name="filter_buttons">
                <a4j:commandLink title="#{messages['gazelle.pam.RefreshResults']}"
                                 render="messageConfigurationPanel">
                    <span class="gzl-icon-refresh"></span>
                </a4j:commandLink>
                <a4j:commandLink title="#{messages['gazelle.pam.ResetCriteria']}"
                                 actionListener="#{managedBean.resetFilter()}"
                                 render="globalForm">
                    <span class="gzl-icon-times-circle"></span>
                </a4j:commandLink>
            </ui:define>
        </s:decorate>
        <s:decorate template="/patient/_patientTable.xhtml"
                    rendered="#{managedBean.displayPatientsList}">
            <ui:param name="patients" value="#{managedBean.patients}"/>
            <ui:define name="rightColumns">
                <ui:insert name="actionOnPatientColumn"/>
            </ui:define>
        </s:decorate>
        <s:decorate template="/layout/panels/_panel_title_footer_id.xhtml"
                    rendered="#{managedBean.displayDDSPanel}">
            <ui:param name="panel_id" value="ddsDiv"/>
            <ui:define name="panel_title">#{messages['gazelle.simulator.pam.PatientGenerationWithDds']}</ui:define>
            <ui:include src="/patient/patientGenerator.xhtml">
                <ui:param name="patientGeneratorBean" value="#{managedBean}"/>
                <ui:param name="displayAllCriteria" value="#{true}"/>
                <ui:param name="ddsEndpoint"
                          value="#{managedBean.ddsWsEndpoint}"/>
            </ui:include>
            <s:div id="genIds">
                <s:decorate template="/layout/form/_checkbox.xhtml" rendered="#{iti30Manager.isBp6Mode()}">
                    <h:selectBooleanCheckbox value="#{managedBean.qualifiedIdentity}" onchange="#{managedBean.qualifiedIdentityCheckboxListener()}">
                        <a4j:ajax event="change" render="genIds"/>
                    </h:selectBooleanCheckbox>
                    #{messages['gazelle.simulator.pam.IdentitQualifie']}
                </s:decorate>
                <h3>#{messages['net.ihe.gazelle.PatientManager.PatientIdentifiers']}</h3>
                <s:decorate template="/layout/form/_checkbox.xhtml">
                        <h:selectBooleanCheckbox value="#{managedBean.useIdsFromDDS}">
                            <a4j:ajax event="change" render="genIds"/>
                        </h:selectBooleanCheckbox>
                    #{messages['gazelle.PAMSimulator.UseIDsFromDDS']}
                </s:decorate>
                <s:decorate template="/layout/form/_checkbox.xhtml"
                    rendered="#{managedBean.isConnectathonFeatureEnabled()}">
                    <h:selectBooleanCheckbox value="#{managedBean.generateIdsForConnectathon}" disabled="#{managedBean.qualifiedIdentity}">
                        <a4j:ajax event="change" render="genCatIds"/>
                    </h:selectBooleanCheckbox>
                    #{messages['gazelle.PAMSimulator.GenerateIdentifiersForConnectathonAssigningAutho']}
                </s:decorate>
                <s:decorate template="/layout/form/_checkbox.xhtml">
                    <h:selectBooleanCheckbox value="#{managedBean.generateIdsForAuthorities}" disabled="#{managedBean.qualifiedIdentity}">
                        <a4j:ajax event="change" render="genIds"/>
                    </h:selectBooleanCheckbox>
                    #{messages['net.ihe.gazelle.patientmanager.UsePredefinedAuthorities']}
                </s:decorate>
                <div class="row">
                    <div class="col-lg-8">
                        <rich:pickList value="#{managedBean.selectedAuthorities}" var="aa"
                                       listWidth="350px" sourceCaption="Available assigning authorities"
                                       targetCaption="Selected assigning authorities" orderable="false"
                                       rendered="#{managedBean.generateIdsForAuthorities}">
                            <s:selectItems value="#{managedBean.availableAuthorities}" var="hd"
                                           label="#{hd.displayWithAmp()}"/>
                            <g:column>
                                <h:outputText value="#{aa.displayWithAmp()}"/>
                            </g:column>
                            <a4j:ajax event="change" listener="#{managedBean.populateBP6selectedAuthorities()}" render="@this"/>
                        </rich:pickList>
                    </div>
                </div>
            </s:div>
            <ui:define name="panel_footer">
                <ui:insert name="ddsButtons"/>
                <a4j:commandButton value="#{messages['gazelle.pam.SelectAnExistingPatient']}"
                                   styleClass="gzl-btn-blue" render="messageConfigurationPanel"
                                   actionListener="#{managedBean.switchToSelectionMode()}"/>
            </ui:define>
        </s:decorate>
        <ui:insert name="selectedPatient"/>
        <ui:insert name="additionalPanels"/>
        <ui:define name="panel_footer">
            <s:div id="sendHL7MessageDiv" rendered="#{renderedForSendMessageButton}">
                <a4j:commandButton
                        value="#{messages['gazelle.simulator.pam.SendMessage']}"
                        actionListener="#{managedBean.sendMessage()}" styleClass="gzl-btn-blue"
                        render="globalForm" disabled="#{disabledForSendMessageButton}"/>
                <s:span rendered="#{disabledForSendMessageButton}">
                    #{messages['gazelle.simulator.pam.disabledForSendMessageButtonInfo']}
                </s:span>
            </s:div>
        </ui:define>
    </ui:decorate>
</ui:composition>
